<html>
<head>
<title>Ogre::RTShader::GLSLProgramWriter Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html">GLSLProgramWriter</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::GLSLProgramWriter Class Reference<div class="ingroups"><a class="el" href="group__RTShader.html">RTShader</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::GLSLProgramWriter" --><!-- doxytag: inherits="Ogre::RTShader::ProgramWriter" -->
<p>GLSL target language writer implementation.  
 <a href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RTShader::GLSLProgramWriter:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RTShader_1_1GLSLProgramWriter__inherit__graph.gif" border="0" usemap="#Ogre_1_1RTShader_1_1GLSLProgramWriter_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RTShader_1_1GLSLProgramWriter_inherit__map" id="Ogre_1_1RTShader_1_1GLSLProgramWriter_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1RTShader_1_1ProgramWriter.html" title="Base class interface for shader program writers." alt="" coords="23,83,231,112"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="49,5,204,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RTShader_1_1GLSLProgramWriter-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a8aeb7973287735ab0e150b3c23baed93">GLSLProgramWriter</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class constructor.  <a href="#a8aeb7973287735ab0e150b3c23baed93"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#adb246108d4c3d88367f04a720d1e2c20">~GLSLProgramWriter</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class destructor.  <a href="#adb246108d4c3d88367f04a720d1e2c20"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#ad39cb4912190dd26c5afed7e15b12a0c">writeSourceCode</a> (std::ostream &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a701b697e8800728c144580eb4d055f14">getTargetLanguage</a> () const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a2dedd0d346cf93b37f379e35775d4e20">writeSourceCode</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the program shader source code.  <a href="#a2dedd0d346cf93b37f379e35775d4e20"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#abc7551e9f276f98d195d32376af988fc">TargetLanguage</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::map<br class="typebreak"/>
&lt; <a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a>, const char * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a5cc1c16cfdbc58e19926386257725cd9">GpuConstTypeToStringMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::map<br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1RTShader_1_1Parameter.html#a91fc3614f191bebf0461676a03750312">Parameter::Semantic</a>, const <br class="typebreak"/>
char * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a3c3bae0a3a5c69fb96dca9e30b2e92e2">ParamSemanticToStringMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::map<br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1RTShader_1_1Parameter.html#a4fa6286f097d19e92a8ed91645fbfbe7">Parameter::Content</a>, const <br class="typebreak"/>
char * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#ab74b3fdd0047f609b4b98acdea22de56">ParamContentToStringMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::map&lt; <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a7e26f3e6f2eb9e3c15849b21fa016351">StringMap</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a407f1d3055a63903319cfb64f0f80249">initializeStringMaps</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize string maps.  <a href="#a407f1d3055a63903319cfb64f0f80249"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#ab26eac7ec4f68c1d9a919202642d7c5d">writeLocalParameter</a> (std::ostream &amp;os, <a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> parameter)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a local parameter.  <a href="#ab26eac7ec4f68c1d9a919202642d7c5d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a342a003c99f6415afb0f07ac141681f1">writeForwardDeclarations</a> (std::ostream &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write forward declarations.  <a href="#a342a003c99f6415afb0f07ac141681f1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a5a4c2d1a088dc83f3d4a123d571a9c41">writeInputParameters</a> (std::ostream &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *function, <a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> gpuType)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the input params of the function.  <a href="#a5a4c2d1a088dc83f3d4a123d571a9c41"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a47a02c2166b98e4df1ff81b1be45cd63">writeOutParameters</a> (std::ostream &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *function, <a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> gpuType)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the output params of the function.  <a href="#a47a02c2166b98e4df1ff81b1be45cd63"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#ab1b6c67defa74dfdce8a0bcd1ccb62cb">writeProgramTitle</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the program title.  <a href="#ab1b6c67defa74dfdce8a0bcd1ccb62cb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a9503345c6d319c8c39cdb1f8c83f10a0">writeUniformParametersTitle</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *program)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the uniform parameters title.  <a href="#a9503345c6d319c8c39cdb1f8c83f10a0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a6417dc1c4838e8df26e98b3c675ec26f">writeFunctionTitle</a> (<a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;os, <a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *function)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a function title.  <a href="#a6417dc1c4838e8df26e98b3c675ec26f"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a5cc1c16cfdbc58e19926386257725cd9">GpuConstTypeToStringMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#ad28d2f707609af264d0ed84e6c8f7f5e">mGpuConstTypeMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a3c3bae0a3a5c69fb96dca9e30b2e92e2">ParamSemanticToStringMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a00784db847d3017b3f746e38227fe403">mParamSemanticMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a7e26f3e6f2eb9e3c15849b21fa016351">StringMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a0f38828e272d54fe4d7283ddb06f1ccc">mInputToGLStatesMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#ab74b3fdd0047f609b4b98acdea22de56">ParamContentToStringMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#ac89d7cf7ee23bcdc145acc98942289cb">mContentToPerVertexAttributes</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a89d9fce3f87c76fd671da29b66bd4967">mGLSLVersion</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#aa8080be296873313a8b54e0200470857">mFragInputParams</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>GLSL target language writer implementation. </p>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html" title="Base class interface for shader program writers.">ProgramWriter</a>. </dd></dl>

<p>Definition at line <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00045">45</a> of file <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a5cc1c16cfdbc58e19926386257725cd9"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::GpuConstTypeToStringMap" ref="a5cc1c16cfdbc58e19926386257725cd9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a>, const char*&gt; <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a5cc1c16cfdbc58e19926386257725cd9">Ogre::RTShader::GLSLProgramWriter::GpuConstTypeToStringMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00091">91</a> of file <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab74b3fdd0047f609b4b98acdea22de56"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::ParamContentToStringMap" ref="ab74b3fdd0047f609b4b98acdea22de56" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="classOgre_1_1RTShader_1_1Parameter.html#a4fa6286f097d19e92a8ed91645fbfbe7">Parameter::Content</a>, const char*&gt; <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#ab74b3fdd0047f609b4b98acdea22de56">Ogre::RTShader::GLSLProgramWriter::ParamContentToStringMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00093">93</a> of file <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3c3bae0a3a5c69fb96dca9e30b2e92e2"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::ParamSemanticToStringMap" ref="a3c3bae0a3a5c69fb96dca9e30b2e92e2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="classOgre_1_1RTShader_1_1Parameter.html#a91fc3614f191bebf0461676a03750312">Parameter::Semantic</a>, const char*&gt; <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a3c3bae0a3a5c69fb96dca9e30b2e92e2">Ogre::RTShader::GLSLProgramWriter::ParamSemanticToStringMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00092">92</a> of file <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a7e26f3e6f2eb9e3c15849b21fa016351"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::StringMap" ref="a7e26f3e6f2eb9e3c15849b21fa016351" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&gt; <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a7e26f3e6f2eb9e3c15849b21fa016351">Ogre::RTShader::GLSLProgramWriter::StringMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00094">94</a> of file <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a8aeb7973287735ab0e150b3c23baed93"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::GLSLProgramWriter" ref="a8aeb7973287735ab0e150b3c23baed93" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a8aeb7973287735ab0e150b3c23baed93">Ogre::RTShader::GLSLProgramWriter::GLSLProgramWriter</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class constructor. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">language</td><td>The target shader language. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="adb246108d4c3d88367f04a720d1e2c20"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::~GLSLProgramWriter" ref="adb246108d4c3d88367f04a720d1e2c20" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#adb246108d4c3d88367f04a720d1e2c20">Ogre::RTShader::GLSLProgramWriter::~GLSLProgramWriter</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class destructor. </p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a701b697e8800728c144580eb4d055f14"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::getTargetLanguage" ref="a701b697e8800728c144580eb4d055f14" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a701b697e8800728c144580eb4d055f14">Ogre::RTShader::GLSLProgramWriter::getTargetLanguage</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#adea123814282cb2fd21f504246647b06" title="Return the target language of this writer.">ProgramWriter::getTargetLanguage</a>. </dd></dl>

<p>Implements <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#adea123814282cb2fd21f504246647b06">Ogre::RTShader::ProgramWriter</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00067">67</a> of file <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a407f1d3055a63903319cfb64f0f80249"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::initializeStringMaps" ref="a407f1d3055a63903319cfb64f0f80249" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a407f1d3055a63903319cfb64f0f80249">Ogre::RTShader::GLSLProgramWriter::initializeStringMaps</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Initialize string maps. </p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a342a003c99f6415afb0f07ac141681f1"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::writeForwardDeclarations" ref="a342a003c99f6415afb0f07ac141681f1" args="(std::ostream &amp;os, Program *program)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a342a003c99f6415afb0f07ac141681f1">Ogre::RTShader::GLSLProgramWriter::writeForwardDeclarations</a> </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write forward declarations. </p>
<p>This is needed so that we can attach library shader at a later step. </p>

</div>
</div>
<a class="anchor" id="a6417dc1c4838e8df26e98b3c675ec26f"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::writeFunctionTitle" ref="a6417dc1c4838e8df26e98b3c675ec26f" args="(StringSerialiser &amp;os, Function *function)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a6417dc1c4838e8df26e98b3c675ec26f">Ogre::RTShader::ProgramWriter::writeFunctionTitle</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>function</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write a function title. </p>

</div>
</div>
<a class="anchor" id="a5a4c2d1a088dc83f3d4a123d571a9c41"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::writeInputParameters" ref="a5a4c2d1a088dc83f3d4a123d571a9c41" args="(std::ostream &amp;os, Function *function, GpuProgramType gpuType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a5a4c2d1a088dc83f3d4a123d571a9c41">Ogre::RTShader::GLSLProgramWriter::writeInputParameters</a> </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>function</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td>
          <td class="paramname"><em>gpuType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the input params of the function. </p>

</div>
</div>
<a class="anchor" id="ab26eac7ec4f68c1d9a919202642d7c5d"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::writeLocalParameter" ref="ab26eac7ec4f68c1d9a919202642d7c5d" args="(std::ostream &amp;os, ParameterPtr parameter)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#ab26eac7ec4f68c1d9a919202642d7c5d">Ogre::RTShader::GLSLProgramWriter::writeLocalParameter</a> </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>&#160;</td>
          <td class="paramname"><em>parameter</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write a local parameter. </p>

</div>
</div>
<a class="anchor" id="a47a02c2166b98e4df1ff81b1be45cd63"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::writeOutParameters" ref="a47a02c2166b98e4df1ff81b1be45cd63" args="(std::ostream &amp;os, Function *function, GpuProgramType gpuType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a47a02c2166b98e4df1ff81b1be45cd63">Ogre::RTShader::GLSLProgramWriter::writeOutParameters</a> </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>function</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td>
          <td class="paramname"><em>gpuType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the output params of the function. </p>

</div>
</div>
<a class="anchor" id="ab1b6c67defa74dfdce8a0bcd1ccb62cb"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::writeProgramTitle" ref="ab1b6c67defa74dfdce8a0bcd1ccb62cb" args="(StringSerialiser &amp;os, Program *program)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#ab1b6c67defa74dfdce8a0bcd1ccb62cb">Ogre::RTShader::ProgramWriter::writeProgramTitle</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the program title. </p>

</div>
</div>
<a class="anchor" id="ad39cb4912190dd26c5afed7e15b12a0c"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::writeSourceCode" ref="ad39cb4912190dd26c5afed7e15b12a0c" args="(std::ostream &amp;os, Program *program)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#ad39cb4912190dd26c5afed7e15b12a0c">Ogre::RTShader::GLSLProgramWriter::writeSourceCode</a> </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a2dedd0d346cf93b37f379e35775d4e20" title="Write the program shader source code.">ProgramWriter::writeSourceCode</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="a2dedd0d346cf93b37f379e35775d4e20"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::writeSourceCode" ref="a2dedd0d346cf93b37f379e35775d4e20" args="(StringSerialiser &amp;os, Program *program)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a2dedd0d346cf93b37f379e35775d4e20">Ogre::RTShader::ProgramWriter::writeSourceCode</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the program shader source code. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">os</td><td>The output stream to write to code into. </td></tr>
    <tr><td class="paramname">program</td><td>The source CPU program for the GPU program code. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classOgre_1_1RTShader_1_1GLSLESProgramWriter.html#a87e5c1203bdc1fafb5ca3be4636e5e32">Ogre::RTShader::GLSLESProgramWriter</a>.</p>

</div>
</div>
<a class="anchor" id="a9503345c6d319c8c39cdb1f8c83f10a0"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::writeUniformParametersTitle" ref="a9503345c6d319c8c39cdb1f8c83f10a0" args="(StringSerialiser &amp;os, Program *program)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramWriter.html#a9503345c6d319c8c39cdb1f8c83f10a0">Ogre::RTShader::ProgramWriter::writeUniformParametersTitle</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringSerialiser.html">StringSerialiser</a> &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>program</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write the uniform parameters title. </p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="ac89d7cf7ee23bcdc145acc98942289cb"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::mContentToPerVertexAttributes" ref="ac89d7cf7ee23bcdc145acc98942289cb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#ab74b3fdd0047f609b4b98acdea22de56">ParamContentToStringMap</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#ac89d7cf7ee23bcdc145acc98942289cb">Ogre::RTShader::GLSLProgramWriter::mContentToPerVertexAttributes</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00102">102</a> of file <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa8080be296873313a8b54e0200470857"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::mFragInputParams" ref="aa8080be296873313a8b54e0200470857" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#aa8080be296873313a8b54e0200470857">Ogre::RTShader::GLSLProgramWriter::mFragInputParams</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00104">104</a> of file <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a89d9fce3f87c76fd671da29b66bd4967"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::mGLSLVersion" ref="a89d9fce3f87c76fd671da29b66bd4967" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a89d9fce3f87c76fd671da29b66bd4967">Ogre::RTShader::GLSLProgramWriter::mGLSLVersion</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00103">103</a> of file <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad28d2f707609af264d0ed84e6c8f7f5e"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::mGpuConstTypeMap" ref="ad28d2f707609af264d0ed84e6c8f7f5e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a5cc1c16cfdbc58e19926386257725cd9">GpuConstTypeToStringMap</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#ad28d2f707609af264d0ed84e6c8f7f5e">Ogre::RTShader::GLSLProgramWriter::mGpuConstTypeMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00098">98</a> of file <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a0f38828e272d54fe4d7283ddb06f1ccc"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::mInputToGLStatesMap" ref="a0f38828e272d54fe4d7283ddb06f1ccc" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a7e26f3e6f2eb9e3c15849b21fa016351">StringMap</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a0f38828e272d54fe4d7283ddb06f1ccc">Ogre::RTShader::GLSLProgramWriter::mInputToGLStatesMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00101">101</a> of file <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="a00784db847d3017b3f746e38227fe403"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::mParamSemanticMap" ref="a00784db847d3017b3f746e38227fe403" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a3c3bae0a3a5c69fb96dca9e30b2e92e2">ParamSemanticToStringMap</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#a00784db847d3017b3f746e38227fe403">Ogre::RTShader::GLSLProgramWriter::mParamSemanticMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00099">99</a> of file <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>.</p>

</div>
</div>
<a class="anchor" id="abc7551e9f276f98d195d32376af988fc"></a><!-- doxytag: member="Ogre::RTShader::GLSLProgramWriter::TargetLanguage" ref="abc7551e9f276f98d195d32376af988fc" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1RTShader_1_1GLSLProgramWriter.html#abc7551e9f276f98d195d32376af988fc">Ogre::RTShader::GLSLProgramWriter::TargetLanguage</a><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00069">69</a> of file <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html">OgreShaderGLSLProgramWriter.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:32
</p>
</body>
</html>
